var belove = angular.module('belove', ['ngRoute','ngResource','ngAnimate','ngSanitize','infinite-scroll','ngOpenFB']);

angular.module('belove').run(['$rootScope','$interval',function($rootScope,$interval) {
    $rootScope.checaPreenchimentoObrigatorio = function(){
        var b = true;
        $("input.requerido, select.requerido").each(function(i,item){
            if ($(item).val() === "") {
                b = false;
                return true;
            }
        });
        return b;
    };

    $rootScope.latitude = undefined;
    $rootScope.longitude = undefined;
    $rootScope.salvarGps = function(pos){
        if (pos !== undefined) {
            $rootScope.latitude = pos.coords.latitude;
            $rootScope.longitude = pos.coords.longitude;
            $.ajax({
                url: url_servidor+"/api/gps_save",
                data: {
                    latitude: $rootScope.latitude,
                    longitude: $rootScope.longitude
                }
            });
        }
    };

    $rootScope.obterGps = function(){
        navigator.geolocation.getCurrentPosition(
            function(pos){$rootScope.salvarGps(pos);},
            function(){
                navigator.geolocation.getCurrentPosition(
                    function(pos){$rootScope.salvarGps(pos);},
                    function(){},
                    {maximumAge:3000,timeout:10000,enableHighAccuracy:false});
            },
            {maximumAge:3000,timeout:5000,enableHighAccuracy:true});
    };
    
    $rootScope.obterGps();
    $interval(function(){$rootScope.obterGps()},30000);

    $rootScope.calcularDistancia = function(latB,lngB) {
        var latA = $rootScope.latitude;
        var lngA = $rootScope.longitude;
        var total = 0;
        if (latA!==null && lngA!==null && latB!==null && lngB!==null)
            try {total = 6371*Math.acos(Math.cos(Math.PI*(90-latB)/180)*Math.cos((90-latA)*Math.PI/180)+Math.sin((90-latB)*Math.PI/180)*Math.sin((90-latA)*Math.PI/180)*Math.cos((lngA-lngB)*Math.PI/180));}
            catch(e){console.log(e)}
        if (isNaN(total)) total = 0;
        return total===0 ? '' : 'aprox '+(total>1 ? total.toFixed(2).replace('.',',') + 'Km' : parseInt(total.toFixed(3).replace('0.','')) + 'm');
    };
}]);

belove.config(['$routeProvider',
    function($routeProvider) {
        $routeProvider.
        when('/', {
            templateUrl: 'views/principal.html',
            controller: 'principalController'
        }).
        when('/principal', {
            templateUrl: 'views/principal.html',
            controller: 'principalController'
        }).
        when('/principal/:tipo', {
            templateUrl: 'views/principal.html',
            controller: 'principalController'
        }).
        when('/meuPerfil', {
            templateUrl: 'views/meuPerfil.html',
            controller: 'meuPerfilController'
        }).
        when('/perfil/:id', {
            templateUrl: 'views/perfil.html',
            controller: 'perfilController'
        }).
        when('/chat/:tipo/:id', {
            templateUrl: 'views/chat.html',
            controller: 'chatController'
        }).
        when('/videochat/:hash', {
            templateUrl: 'views/videochat.html',
            controller: 'videochatController'
        }).
        when('/solicitacaoAmizade', {
            templateUrl: 'views/solicitacao_amizade.html',
            controller: 'solicitacaoAmizadeController'
        }).
        when('/buscaAvancada', {
            templateUrl: 'views/busca_avancada.html',
            controller: 'buscaAvancadaController'
        }).
        when('/buscaResultado', {
            templateUrl: 'views/busca_resultado.html',
            controller: 'buscaResultadoController'
        }).
        when('/belovers', {
            templateUrl: 'views/belovers.html',
            controller: 'beloversController'
        }).
        when('/galeria', {
            templateUrl: 'views/galeria.html',
            controller: 'galeriaController'
        }).
        when('/login', {
            templateUrl: 'views/login.html',
            controller: 'loginController'
        }).
        when('/login/:erro', {
            templateUrl: 'views/login.html',
            controller: 'loginController'
        }).
        when('/logout', {
            templateUrl: 'views/logout.html',
            controller: 'logoutController'
        }).
        when('/cadastroEditar', {
            templateUrl: 'views/cadastro_editar.html',
            controller: 'cadastroEditarController'
        }).
        when('/cadastroEtapa1', {
            templateUrl: 'views/cadastro_etapa1.html',
            controller: 'cadastroEtapa1Controller'
        }).
        when('/cadastroEtapa2', {
            templateUrl: 'views/cadastro_etapa2.html',
            controller: 'cadastroEtapa2Controller'
        }).
        when('/cadastroEtapa3', {
            templateUrl: 'views/cadastro_etapa3.html',
            controller: 'cadastroEtapa3Controller'
        }).
        when('/cadastroEtapa4', {
            templateUrl: 'views/cadastro_etapa4.html',
            controller: 'cadastroEtapa4Controller'
        }).
        when('/cadastroEtapa5', {
            templateUrl: 'views/cadastro_etapa5.html',
            controller: 'cadastroEtapa5Controller'
        }).
        when('/cadastroEtapa7', {
            templateUrl: 'views/cadastro_etapa7.html',
            controller: 'cadastroEtapa7Controller'
        }).
        when('/cadastroEtapa8', {
            templateUrl: 'views/cadastro_etapa8.html',
            controller: 'cadastroEtapa8Controller'
        }).
        when('/configuracoes', {
            templateUrl: 'views/configuracoes.html',
            controller: 'configuracoesController'
        }).
        when('/reativar', {
            templateUrl: 'views/reativar.html',
            controller: 'reativarController'
        }).
        when('/cancelarPlano', {
            templateUrl: 'views/cancelar_plano.html',
            controller: 'cancelarPlanoController'
        }).
        when('/alterarPlano', {
            templateUrl: 'views/alterar_plano.html',
            controller: 'alterarPlanoController'
        }).
        when('/loginInstagram', {
            templateUrl: 'views/loginInstagram.html',
            controller: 'loginInstagramController'
        }).
        otherwise({
            redirectTo: '/'
        });
    }
]);

belove.factory('Commons', function($http) {
    var parametros;
    var obj = {
        setParametrosBusca : function(p) {
            parametros = p;
        },
        getParametrosBusca : function() {
            return parametros;
        },
        getChave : function(key) {
            return localStorage.getItem(key);
        },
        setChave : function(key,value) {
            localStorage.setItem(key, value);
        },
        removerChave : function(key) {
            localStorage.removeItem(key);
        },
        limparStorage : function() {
            localStorage.clear();
        },
        getCaminhoImagem : function(controller,action,id) {
            return url_servidor+"/"+controller+"/"+action+"/"+id;
        },
        executarLogout : function(callback) {
            $.ajax({
                url: url_servidor+'/api/logout',
                type: 'POST',
                success: function(){callback();},
                error: function(e){obj.mensagemErro();}
            });
        },
        getDadosUsuario : function(callback) {
            $.ajax({
                url: url_servidor+'/api/dados_usuario',
                type: 'POST',
                success: function(data){callback(data);},
                error: function(e){obj.mensagemErro();}
            });
        },
        getDadosUsuarioInterval : function(callback) {
            $.ajax({
                url: url_servidor+'/api/dados_usuario',
                type: 'POST',
                success: function(data){callback(data);}
            });
        },
        dadosPerfil : function(id,callback) {
            $.ajax({
                url: url_servidor+'/api/dados_perfil',
                type: 'POST',
                data: {id: id},
                success: function(data){callback(data);},
                error: function(e){obj.mensagemErro();}
            });
        },
        getAmizades : function(callback) {
            $.ajax({
                url: url_servidor+'/api/amizades',
                type: 'POST',
                success: function(data){callback(data);},
                error: function(e){obj.mensagemErro();}
            });
        },
        aceitarAmizade : function(id,callback) {
            $.ajax({
                url: url_servidor+'/api/aceitar_amizade',
                type: 'POST',
                data: {id: id},
                success: function(){callback();},
                error: function(e){obj.mensagemErro();}
            });
        },
        recusarAmizade : function(id,callback) {
            $.ajax({
                url: url_servidor+'/api/recusar_amizade',
                type: 'POST',
                data: {id: id},
                success: function(){callback();},
                error: function(e){obj.mensagemErro();}
            });
        },
        desfazerAmizade : function(dados,callback) {
            $.ajax({
                url: url_servidor+'/api/desfazer_amizade',
                type: 'POST',
                data: dados,
                success: function(){callback();},
                error: function(e){obj.mensagemErro();}
            });
        },
        enviarConvite : function(id,mensagem,callback) {
            $.ajax({
                url: url_servidor+'/api/enviar_convite',
                type: 'POST',
                data: {id: id, mensagem: mensagem},
                success: function(){callback();},
                error: function(e){obj.mensagemErro();}
            });
        },
        verificarMatch : function(id,callback) {
            $.ajax({
                url: url_servidor+'/api/verificar_match',
                type: 'POST',
                data: {id: id},
                success: function(data){callback(data);},
                error: function(e){obj.mensagemErro();}
            });
        },
        recusarSugestao : function(id,callback) {
            $.ajax({
                url: url_servidor+'/api/recusar_sugestao',
                type: 'POST',
                data: {id: id},
                success: function(){callback();},
                error: function(e){obj.mensagemErro();}
            });
        },
        proximoBelover : function(callback) {
            $.ajax({
                url: url_servidor+'/api/proximo_belover',
                type: 'POST',
                success: function(data){callback(data);},
                error: function(e){obj.mensagemErro();}
            });
        },
        buscarConfiguracoes : function(callback) {
            $.ajax({
                url: url_servidor+'/api/buscar_configuracoes',
                type: 'POST',
                success: function(data){callback(data);},
                error: function(e){obj.mensagemErro();}
            });
        },
        buscarResultado : function(params,callback) {
            $.ajax({
                url: url_servidor+'/api/buscar_resultados',
                type: 'POST',
                data: params,
                success: function(data){callback(data);},
                error: function(e){obj.mensagemErro();}
            });
        },
        buscarConversa : function(id,tipo,callback) {
            $.ajax({
                url: url_servidor+'/api/buscar_conversa',
                type: 'POST',
                data: {id: id, tipo: tipo},
                success: function(data){callback(data);},
                error: function(e){obj.mensagemErro();}
            });
        },
        buscarFotos : function(callback) {
            $.ajax({
                url: url_servidor+'/api/buscar_fotos',
                type: 'POST',
                success: function(data){callback(data);},
                error: function(e){obj.mensagemErro();}
            });
        },
        enviarEsqueciSenha : function(email,callback) {
            $.ajax({
                url: url_servidor+'/cadastro/recuperar_senha',
                type: 'POST',
                data: {recuperar_email: email},
                success: function(){callback();},
                error: function(e){obj.mensagemErro();}
            });
        },
        fecharConversa : function(id,callback) {
            $.ajax({
                url: url_servidor+'/conversa/fechar_conversa',
                type: 'POST',
                data: {id:id},
                success: function(){callback();},
                error: function(e){obj.mensagemErro();}
            });
        },
        mudarDataAcesso : function() {
            $.ajax({
                url: url_servidor+'/api/mudar_data_acesso',
                type: 'POST',
                success: function(){},
                error: function(e){obj.mensagemErro();}
            });
        },
        marcarAcessouBelovers : function() {
            $.ajax({
                url: url_servidor+'/api/marcar_acessou_belovers',
                type: 'POST',
                success: function(){},
                error: function(e){obj.mensagemErro();}
            });
        },
        getVideochatHash : function(callback) {
            $.ajax({
                url: url_servidor+'/conversa/video_gerar_hash',
                type: 'POST',
                success: function(data){callback(data);},
                error: function(e){obj.mensagemErro();}
            });
        },
        encerrarSala : function(hash,callback) {
            $.ajax({
                url: url_servidor+'/encerrar_sala/'+hash,
                complete: function(){callback();}
            });
        },
        getRegistro : function(username,password,callback) {
            $.ajax({
                url: url_servidor+'/api/registrar',
                type: 'POST',
                data: {
                    username: username,
                    password: password
                },
                success: function(data){callback(data);},
                error: function(e){obj.mensagemErro();}
            });
        },
        getEtapa : function(i,callback) {
            $.ajax({
                url: url_servidor+'/api/etapa'+i,
                type: 'POST',
                success: function(data){callback(data);},
                error: function(e){obj.mensagemErro();}
            });
        },
        setEtapa : function(i,params,callback) {
            $.ajax({
                url: url_servidor+'/api/etapa'+i+'_save',
                type: 'POST',
                data: params,
                success: function(data){callback(data);},
                error: function(e){obj.mensagemErro();}
            });
        },
        sendLoginRedeSocial : function(url,params,callback) {
            $.ajax({
                url: url_servidor+'/redeSocial/'+url,
                type: 'POST',
                data: params,
                success: function(data){callback(data);},
                error: function(e){obj.mensagemErro();}
            });
        },
        usuarioDesativado : function(callback) {
            $.ajax({
                url: url_servidor+'/api/usuario_desativado',
                type: 'POST',
                success: function(data){callback(data);},
                error: function(e){obj.mensagemErro();}
            });
        },
        cancelarConta : function(callback) {
            $.ajax({
                url: url_servidor+'/api/cancelar_conta',
                type: 'POST',
                success: function(data){callback(data);},
                error: function(e){obj.mensagemErro();}
            });
        },
        reativarConta : function(callback) {
            $.ajax({
                url: url_servidor+'/api/reativar_conta',
                type: 'POST',
                success: function(data){callback(data);},
                error: function(e){obj.mensagemErro();}
            });
        },
        cancelarPlano : function(params,callback) {
            $.ajax({
                url: url_servidor+'/api/cancelar_plano',
                type: 'POST',
                data: params,
                success: function(data){callback(data);},
                error: function(e){obj.mensagemErro();}
            });
        },
        assinaturaGratuito : function(callback) {
            $.ajax({
                url: url_servidor+'/api/assinatura_gratuito',
                type: 'POST',
                success: function(data){callback(data);},
                error: function(e){obj.mensagemErro();}
            });
        },
        assinaturaPagamento : function(params,callback) {
            $.ajax({
                url: url_servidor+'/assinatura/pagamento',
                type: 'POST',
                data: params,
                success: function(data){callback(data);},
                error: function(e){obj.mensagemErro();}
            });
        },
        configuracaoNotificacao : function(params,callback) {
            $.ajax({
                url: url_servidor+'/api/configuracao_notificacao',
                type: 'POST',
                data: params,
                success: function(data){callback(data);},
                error: function(e){obj.mensagemErro();}
            });
        },
        renderizarPixel : function(callback) {
            $.ajax({
                url: url_servidor+'/api/renderizar_pixel',
                type: 'POST',
                success: function(data){callback(data);},
                error: function(e){obj.mensagemErro();}
            });
        },
        mensagemErro: function() {
            modalAlerta('Erro','Houve uma falha de conexão no aplicativo. Verifique se você está com acesso à internet ou tente novamente mais tarde!');
        },
        setupPush: function() {
            try {
                var push = PushNotification.init({
                    "android": {
                        "senderID": "1051480502686"
                    },
                    "ios": {
                        "senderID": "1051480502686",
                        "sound": "true",
                        "vibration": "true",
                        "badge": "true",
                        "clearBadge": "true"
                    },
                    "windows": {}
                }); 
                push.on('registration',function(data){
                    var regId = obj.getChave('registrationId');
                    if (data.registrationId!==regId) {
                        $.ajax({
                            url: url_servidor+'/api/registrar_pushId',
                            type: 'POST',
                            data: {
                                deviceId: data.registrationId,
                                plataforma: window.device.platform
                            },
                            success: function() {obj.setChave('registrationId',data.registrationId);},
                            error: function (e) {console.log(e);}
                        });
                    }
                }); 
                push.on('error',function(e){console.log("push error = " + e.message);}); 
                push.on('notification',function(data){});
            }
            catch(e) {console.log(e);}
        },
        scriptHeader : function() {
            $('.bloco_abas').hide();
            $('#content .bloco_abas:nth-child(1)').show();
            $('.bloco_abas:first').show();
            $(".aba").click(function(){
                $(".aba").removeClass("atv");
                $(this).addClass("atv");
                var indice = $(this).parent().index();
                indice++;
                $("#content .bloco_abas").hide();
                $("#content .bloco_abas:nth-child("+indice+")").show();
                return false;
            });

            $(".header_btn").click(function(){
                $(".menu").animate({right:"0"},500);
            });

            var altura = $(window).height();
            var alturaHeader = $('.bgheader').height();
            var alturaConversa = altura - alturaHeader;
            $('.conversas_content').css('height',alturaConversa);
            $('.chat_content').css('height',altura);

            var alturaImg = $('.conversa_img').height();
            $('.conversa_txt, .amizade_btns').css('height',alturaImg);

            var alturaImgMenu = $('.menu_imagem').height();
            $('.menu_conversa').css('height',alturaImgMenu);
            $('.menu_contatos').css('height',alturaImgMenu);

            $('.menus_box .box_menus .menu_imagem_item').each(function(){
                var alturaMenu = $(this).height();
                $(this).closest('.box_menus').find('.menu_cont_item').css('height',alturaMenu);
            });

            var alturaBtn = $('.box_acoes').height();
            var alturaImgPerfilAdd = altura-alturaBtn-2;
            $('.perfil_imgadd').css('height',alturaImgPerfilAdd);

            var alturaImgChat = $('.chat_img').height();
            $('.chat_title').css('height',alturaImgChat);

            var alturaHeaderChat = $('.bgheader_chat').outerHeight(true);
            var alturaEnvioChat = $('.chat_bgenvio').outerHeight(true);
            var totalAlturaChat = altura-alturaHeaderChat-alturaEnvioChat;
        },
        removerOwl : function() {
            if ($('#owl-demo').data('owlCarousel') !== undefined) {
                while ($("#owl-demo").data('owlCarousel').removeItem() !== false) {}
                $('#owl-demo').data('owlCarousel').destroy();
            }
        },
        scriptOwl : function() {
            $("#owl-demo").owlCarousel({
                autoPlay: false,
                navigation: false,
                slideSpeed: 800,
                pagination: true,
                paginationSpeed: 500,
                singleItem: true
            });
        },
        scriptSlider : function(i1,i2,a1,a2) {
            $("#idadei").val(i1);
            $("#idadef").val(i2);
            $("#slider-idade").slider({range: true, min: 18, max: 80, values: [i1,i2],
                create: function() {$(".slider_idade_p").html('Idade ['+i1+' - '+i2+' anos]');},
                slide: function(event,ui) {
                    $(".slider_idade_p").html('Idade ['+ui.values[0]+' - '+ui.values[1]+' anos]');
                    $("#idadei").val(ui.values[0]);
                    $("#idadef").val(ui.values[1]);
                }
            });
            $("#alturai").val(a1);
            $("#alturaf").val(a2);
            $("#slider-altura").slider({range: true, min: 100, max: 240, values: [a1,a2],
                create: function() {$(".slider_altura_p").html('Altura ['+a1+' - '+a2+' cm]');},
                slide: function(event,ui) {
                    $(".slider_altura_p").html('Altura ['+ui.values[0]+' - '+ui.values[1]+' cm]');
                    $("#alturai").val(ui.values[0]);
                    $("#alturaf").val(ui.values[1]);
                }
            });
        },
        scriptCidadeAutocomplete : function() {
            $("#cidade").autocomplete({
                minLength: 2,
                source: function(request, response) {
                    $.ajax({
                        url: "../cep/municipio",
                        dataType: "json",
                        data: {id: request.term},
                        success: function(data) {
                            response($.map(data, function(item) {
                                return {
                                    cidade: item.cidade,
                                    estado: item.estado
                                }
                            }));
                        }
                    });
                },
                focus: function(event, ui) {
                    $("#cidade").val(ui.item.cidade);
                },
                select: function(event, ui) {
                    $("#cidade").val(ui.item.cidade);
                    $("#estado").val(ui.item.estado);
                    return false;
                }
            })
            .data("ui-autocomplete")._renderItem = function(ul, item) {
                return $("<li>")
                    .data("item.autocomplete", item)
                    .append("<a>"+item.cidade+" - <b>"+item.estado+"</b></a>")
                    .appendTo(ul);
            };
        }
    };

    return obj;
});