belove.controller('cadastroEditarController', function($rootScope,$scope,$routeParams,$timeout,Commons){

    ga('set', 'page', '/m/cadastro_etapa1');
    ga('send', 'pageview');
    
    $scope.abrirModal = function(s) {
        $("#modal-"+s).modal();
    };
    
    $scope.pesquisaCidade = function() {
        $("#cidade").autocomplete({
            minLength: 2,
            source: function(request, response) {
                $.ajax({
                    url: url_servidor+'/cep/municipio',
                    dataType: "json",
                    data: {id: request.term},
                    success: function(data) {
                        response($.map(data, function(item) {
                            return {
                                cidade: item.cidade,
                                estado: item.estado
                            }
                        }));
                    }
                });
            },
            focus: function(event, ui) {
                $("#cidade").val(ui.item.cidade);
            },
            select: function(event, ui) {
                $scope.cidade = ui.item.cidade;
                $scope.estado = ui.item.estado;
                $timeout(function(){$scope.$apply();});
                return false;
            }
        })
        .data("ui-autocomplete")._renderItem = function(ul, item) {
            return $("<li>")
                .data("item.autocomplete", item)
                .append("<a>"+item.cidade+" - <b>"+item.estado+"</b></a>")
                .appendTo(ul);
        }
    };
    
    $scope.obterSigno = function() {
        $("#meu-signo").hide();
        $scope.signo = "";
        if ($scope.dia !== "" && $scope.mes !== "" && $scope.ano !== "") {
            var zod_signs = ["Capricórnio","Aquário","Peixes","Áries","Touro","Gêmeos","Câncer","Leão","Virgem","Libra","Escorpião","Sagitário"];
            var day = parseInt($scope.dia);
            var month = parseInt($scope.mes);
            var zodiacSign = "";
            switch(month) {
                case 1: {if(day < 20) zodiacSign = zod_signs[0]; else zodiacSign = zod_signs[1];}break;
                case 2: {if(day < 19) zodiacSign = zod_signs[1]; else zodiacSign = zod_signs[2];}break;
                case 3: {if(day < 21) zodiacSign = zod_signs[2]; else zodiacSign = zod_signs[3];}break;
                case 4: {if(day < 20) zodiacSign = zod_signs[3]; else zodiacSign = zod_signs[4];}break;
                case 5: {if(day < 21) zodiacSign = zod_signs[4]; else zodiacSign = zod_signs[5];}break;
                case 6: {if(day < 21) zodiacSign = zod_signs[5]; else zodiacSign = zod_signs[6];}break;
                case 7: {if(day < 23) zodiacSign = zod_signs[6]; else zodiacSign = zod_signs[7];}break;
                case 8: {if(day < 23) zodiacSign = zod_signs[7]; else zodiacSign = zod_signs[8];}break;
                case 9: {if(day < 23) zodiacSign = zod_signs[8]; else zodiacSign = zod_signs[9];}break;
                case 10: {if(day < 23) zodiacSign = zod_signs[9]; else zodiacSign = zod_signs[10];}break;
                case 11: {if(day < 22) zodiacSign = zod_signs[10]; else zodiacSign = zod_signs[11];}break;
                case 12: {if(day < 22) zodiacSign = zod_signs[11]; else zodiacSign = zod_signs[0];}break;
            }
            $("#meu-signo").show();
            $scope.signo = zodiacSign;
        }
    };
    
    $scope.enviar = function() {
        var s1 = $("#senha1").val();
        var s2 = $("#senha2").val();
        if (s1 !== "" && s2 !== "" && s1 !== s2)
            modalAlerta('Erro','As senhas informadas são diferentes.');
        else {
            if ($rootScope.checaPreenchimentoObrigatorio()) {
                var params = {};
                params.username = $scope.username;
                params.sexo = $scope.sexo;
                params.interesseSexual = $scope.interesseSexual;
                params.dia = $scope.dia;
                params.mes = $scope.mes;
                params.ano = $scope.ano;
                params.signo = $scope.signo;
                params.tipoRelacionamento = $scope.tipoRelacionamento;
                params.cidade = $scope.cidade;
                params.estado = $scope.estado;
                params.senha1 = $("#senha1").val();
                params.senha2 = $("#senha2").val();
                Commons.setEtapa('1',params,function(data){
                    window.location.href = "#/cadastroEtapa2";
                });
            }
            else
                modalAlerta('Erro','Campos obrigatórios não foram preenchidos!');
        }
    };

    $scope.iniciarEtapa = function() {
        Commons.getEtapa('1',function(data){
            $scope.username = data.username.indexOf('@facebook.com')>-1 || data.username.indexOf('@instagram.com') >-1 ? '' : data.username;
            $scope.sexo = data.sexo;
            $scope.sexoList = data.sexoList;
            $scope.interesseSexual = data.interesseSexual;
            $scope.interesseSexualList = data.interesseSexualList;
            $scope.dia = data.dia;
            $scope.diaList = data.diaList;
            $scope.mes = data.mes;
            $scope.mesList = [{key:1,value:'Janeiro'},{key:2,value:'Fevereiro'},{key:3,value:'Março'},{key:4,value:'Abril'},{key:5,value:'Maio'},{key:6,value:'Junho'},{key:7,value:'Julho'},{key:8,value:'Agosto'},{key:9,value:'Setembro'},{key:10,value:'Outubro'},{key:11,value:'Novembro'},{key:12,value:'Dezembro'}];
            $scope.ano = data.ano;
            $scope.anoList = data.anoList;
            $scope.signo = data.signo;
            $scope.tipoRelacionamento = data.tipoRelacionamento;
            $scope.tipoRelacionamentoList = data.tipoRelacionamentoList;
            $scope.cidade = data.cidade;
            $scope.estado = data.estado;
            $scope.estadoList = data.estadoList;
            $timeout(function(){
                $scope.obterSigno();
                $scope.pesquisaCidade();
                $scope.$apply();
            });
        });
    };

    $rootScope.mostrar_menu = false;
    if ($rootScope.logado === undefined || $rootScope.logado === false)
        window.location.href = "#/principal";
    else
        $scope.iniciarEtapa();
});
