belove.controller('chatController', function($rootScope,$scope,$routeParams,$timeout,Commons,$sce){

    ga('set', 'page', '/m/chat');
    ga('send', 'pageview');

    $scope.socket_json = undefined;
    $rootScope.mostrar_menu = false;
    $scope.mostrar_link_perfil = $routeParams.tipo!=='s';
    
    $scope.voltar = function() {
        window.history.back();
    };
    
    $scope.converterLink = function(texto) {
        return $sce.trustAsHtml(texto);
    };
    
    abrirTelaChat = function(hash) {
        window.location.href = "#/videochat/"+hash;
    };
    
    $scope.videoChat = function() {
        Commons.getVideochatHash(function(data){
            if (data.hash !== undefined) {
                var msg = "Gostaria de iniciar uma chamada de video com você, <a href=\"javascript:void(0)\" onclick=\"abrirTelaChat('"+data+"')\">ACEITAR</a>";
                if ($scope.socket_json === undefined)
                    criarSocket($routeParams.tipo==='s' ? 'sala' : 'usuario',$routeParams.tipo==='s' ? $routeParams.id : $rootScope.id_usuario);
                $scope.socket_json.emit('bate_papo_belove',{
                    ido: $rootScope.id_usuario,
                    idd: $scope.id,
                    ids: parseInt($routeParams.id),
                    msg_texto: msg,
                    msg: template_msg('L',$rootScope.nome_usuario,msg,$rootScope.id_usuario),
                    salaBP: $routeParams.tipo==='s'
                });
                abrirTelaChat(data.hash);
            }
            else modalAlerta('Erro',data.erro);
        });
    };
    
    $scope.abrirPerfil = function() {
        $scope.socket_json = undefined;
        window.location.href = "#/perfil/"+$scope.id;
    };
    
    $scope.apagarConversa = function() {
        if ($routeParams.tipo==='s') {
            modalConfirmacao('Aceitar','Tem certeza que deseja sair?',function(){
                $scope.socket_json = undefined;
                window.location.href = "#/principal";
            });
        }
        else {
            modalConfirmacao('Aceitar','Tem certeza que deseja apagar a conversa?',function(){
                Commons.fecharConversa($scope.id,function(){
                    $scope.socket_json = undefined;
                    window.location.href = "#/principal";
                });
            });
        }
    };
    
    $scope.recusar = function(i) {
        if (i === 0)
            $("#modal-desfazer-amizade").modal();
        else {
            $("#form-da-opt2").click();
            $("#form-denuncia-observacao").val("");
            $("#modal-denuncia").modal();
        }
    };

    $rootScope.desfazerAmizade = function() {
        Commons.desfazerAmizade({id:$scope.id},function(){
            $scope.socket_json = undefined;
            window.location.href = "#/principal";
        });
    };

    $rootScope.denunciar = function() {
        Commons.desfazerAmizade({id:$scope.id,observacao:$("#form-denuncia-observacao").val(),opt:$("input[name=form-da-opt]:checked").val()},function(){
            $scope.socket_json = undefined;
            window.location.href = "#/principal";
        });
    };

    $scope.enviarMensagem = function() {
        if ($scope.socket_json === undefined)
            criarSocket($routeParams.tipo==='s' ? 'sala' : 'usuario',$routeParams.tipo==='s' ? $routeParams.id : $rootScope.id_usuario);
        $scope.socket_json.emit('bate_papo_belove',{
            ido: $rootScope.id_usuario,
            idd: $scope.id,
            ids: parseInt($routeParams.id),
            msg_texto: $("#mensagem").val(),
            msg: template_msg('L',$rootScope.nome_usuario,$("#mensagem").val(),$rootScope.id_usuario),
            salaBP: $routeParams.tipo==='s'
        });
        adicionarHistorico({data:moment(new Date()).format("DD/MM/YY HH:mm"),mensagem:$("#mensagem").val(),usuarioEnviou:$rootScope.id_usuario});
        $("#mensagem").val("");
        $("#mensagem").focus();
        $timeout(function() {
            $scope.$apply();
            $(".chat_content").each(function(i,item){item.scrollTop = item.scrollHeight;});
        });
    };

    $scope.recarregar = function() {
        Commons.buscarConversa($routeParams.id,$routeParams.tipo,function(data){
            $scope.id = data.id;
            $scope.nome = data.nome;
            $scope.foto = $routeParams.tipo==='s' ? Commons.getCaminhoImagem('conversa','foto_sala',data.id) : Commons.getCaminhoImagem('carregarFoto','perfil',data.id)+"?dimensao=100";
            $scope.historico = data.historico;
            $scope.linkPerfil = data.linkPerfil;
            $scope.salaBP = $routeParams.tipo!=='s';
            
            $rootScope.nLidos -= data.contador;

            criarSocket($routeParams.tipo==='s' ? 'sala' : 'usuario',$routeParams.tipo==='s' ? $routeParams.id : $rootScope.id_usuario);
            
            $timeout(function() {
                $rootScope.$apply();
                Commons.scriptHeader();
                $("#mensagem").focus();
                
                $scope.$apply();
                $(".chat_content").each(function(i,item){item.scrollTop = item.scrollHeight;});
            });
        });
    };

    $scope.enviarEnter = function(e) {
        if (e.charCode === 13 || e.keyCode === 13) {
            e.preventDefault();
            $scope.enviarMensagem();
        }
    };
    
    adicionarHistorico = function(params) {
        if ($scope.historico === undefined) $scope.historico = [];
        $scope.historico.push(params);
    };

    criarSocket = function(nome,id) {
        if (id !== undefined) {
            var idu = $rootScope.id_usuario;
            var nome_usuario = $rootScope.nome_usuario;
            var ido = parseInt($routeParams.id);
            var mostrar_link_perfil = $scope.mostrar_link_perfil;
            var sk = io('https://chat.belove.com.br:3000',{'force new connection':true,'sync disconnect on unload':false});
            sk.emit('info',{
                nome: nome+'_'+id,
                ido: idu,
                ids: id,
                salaBP: nome==='sala',
                msg: nome==='sala' ? template_msg_entrousaiu(nome_usuario+' saiu da sala') : '',
                msg_texto: nome==='sala' ? nome_usuario+' saiu da sala' : '',
                msg2: nome==='sala' ? template_msg_entrousaiu(nome_usuario+' entrou na sala') : '',
                msg2_texto: nome==='sala' ? nome_usuario+' entrou na sala' : ''
            });
            sk.on('mensagem',function(m){
                if (m.ido !== idu && (m.salaBP || (!m.salaBP && m.ido === ido)))
                    recebiMensagem(m);
            });
            sk.on('online',function(m){
                $(".img_status_usuario").removeClass('icone-online').addClass('icone-offline');
                $("#div-videochamada").hide();
                for (var i=0; i<m.online.length; i++) {
                    $(".img_status_"+m.online[i]).removeClass('icone-offline').addClass('icone-online');
                    if (mostrar_link_perfil && $(".img_status_"+m.online[i]).val() !== undefined && $(".img_status_"+m.online[i]).prop("class").indexOf("icone-online")>0) $("#div-videochamada").show();
                }
            });
            $scope.socket_json = sk;
        }
    };

    recebiMensagem = function(m) {
        if (!m.salaBP) {
            adicionarHistorico({data:moment(m.data).format("DD/MM/YY HH:mm"),mensagem:m.msg_texto,usuarioEnviou: m.ido});
        }
        else {
            adicionarHistorico({data:moment(m.data).format("DD/MM/YY HH:mm"),mensagem:m.msg_texto,usuarioEnviou: m.ids});
        }

        $timeout(function() {
            $scope.$apply();
            $(".chat_content").each(function(i,item){item.scrollTop = item.scrollHeight;});
        });
    };

    template_msg = function(s,n,t,id) {
        return '<li>'+
            '<article class="messages'+s+'">'+
            '<div class="messages'+s+'_f">'+
            '<header>'+
            '<h1'+(s === 'R' ? 'class="fontzero"' : '')+'>'+
            '<a href="'+$scope.linkPerfil+'/'+id+'">'+n+'</a>'+
        '</h1>'+
        '</header>'+
        '<p>'+t+'</p>'+
        '<p class="mensagem-horario">'+moment(new Date()).format("DD/MM/YY HH:mm")+'</p>'+
        '</div>'+
        '</article>'+
        '</li>';
    };

    template_msg_entrousaiu = function(t) {
        return '<li>'+
            '<article class="entrou_saiu">'+
            '<div>'+
            '<p>'+t+'</p>'+
            '<p class="mensagem-horario">'+moment(new Date()).format("DD/MM/YY HH:mm")+'</p>'+
            '</div>'+
            '</article>'+
            '</li>';
    };

    if ($rootScope.logado === undefined || $rootScope.logado === false)
        window.location.href = "#/principal";
    else
        $scope.recarregar();
});