belove.controller('galeriaController', function($rootScope,$scope,$routeParams,$route,$timeout,Commons){

    ga('set', 'page', '/m/galeria');
    ga('send', 'pageview');
    
    $scope.voltar = function() {
        window.history.back();
    };
    
    $scope.abrirImagem = function(id) {
        $scope.foto = undefined;
        $.each($scope.fotos,function(i,item){
            if (item.id===id){ 
                $scope.foto = item;
                return false;
            }
        });
        $("#div-galeria-imagem").css({"background":'url('+$scope.foto.foto+') top center no-repeat'});
        $("#modal-galeria-imagem").fadeIn();
    };
    
    $scope.abrirRemover = function(id) {
        $scope.foto = undefined;
        $.each($scope.fotos,function(i,item){
            if (item.id===id){ 
                $scope.foto = item;
                return false;
            }
        });
        $("#modal-confirmacao .modal-title").html("Remover");
        $("#modal-confirmacao .modal-body").html('<p>Você tem certeza que quer remover a imagem?</p>');
        $("#modal-confirmacao-sim").bind("click",$scope.remover);
        $("#modal-confirmacao-nao").bind("click",$scope.cancelar);
        $("#modal-confirmacao").modal();
    };
    
    $scope.remover = function() {
        $.ajax({
            url: url_servidor+'/api/remover_foto',
            method: "post",
            data: {
                id: $scope.foto.id
            },
            success: function(data){
                $("#menu-imagem-perfil").css("background-image",$("#menu-imagem-perfil").css("background-image").replace(')','&t='+new Date().getTime()+")"));
            },
            complete: function(){
                $("#modal-confirmacao").modal('hide');
                $route.reload();
            }
        });
    };
    
    $scope.cancelar = function() {
        $("#modal-confirmacao").modal('hide');
    };
    
    $scope.atualizar = function() {
        $.ajax({
            url: url_servidor+'/api/atualizar_foto',
            method: "post",
            data: {
                id: $scope.foto.id,
                privacidade: $scope.foto.privacidade,
                privacidadeAmigos: JSON.stringify($scope.foto.privacidadeAmigos),
                descricao: $scope.foto.descricao,
                perfil: $scope.foto.perfil
            },
            success: function(data){
                if (data.perfil) $("#menu-imagem-perfil").css("background-image",$("#menu-imagem-perfil").css("background-image").replace(')','&t='+new Date().getTime()+")"));
            },
            complete: function(){
                $("#modal-galeria-imagem").fadeOut();
                $(".modal-backdrop").fadeOut();
                $route.reload();
            }
        });
    };

    $scope.buscarFotos = function() {
        Commons.buscarFotos(function(data){
            $scope.privacidadeList = data.privacidadeList;
            $scope.privacidadeAmigosList = data.privacidadeAmigosList;
            $scope.fotos = data.fotos;
            if ($scope.fotos.length>0) {
                $.each($scope.fotos,function(i,item){
                    $scope.fotos[i].foto = Commons.getCaminhoImagem('carregarFoto','show',item.id);
                });
            }
            $timeout(function(){
                $scope.$apply();
            });
        });
    };

    $rootScope.mostrar_menu = true;
    if ($rootScope.logado === undefined || $rootScope.logado === false)
        window.location.href = "#/principal";
    else {
        Commons.scriptHeader();
        $scope.buscarFotos();
    }
});