belove.controller('videochatController', function($rootScope,$scope,$routeParams,$timeout,Commons){

    ga('set', 'page', '/m/videochat');
    ga('send', 'pageview');
    
    $scope.voltar = function() {
        window.history.back();
    };
    
    $scope.abrirConfiguracoes = function() {
        $("#modal-config-video").modal();
    };
    
    $scope.fecharVideo = function() {
        Commons.encerrarSala($routeParams.hash,function(){
            window.history.back();
        });
    };
    
    $scope.recarregar = function() {
        $timeout(function(){
            
            var videoElement = document.querySelector('video');
            var audioInputSelect = document.querySelector('select#audioEntrada');
            var audioOutputSelect = document.querySelector('select#audioSaida');
            var videoSelect = document.querySelector('select#videoSelect');
            var selectors = [audioInputSelect, audioOutputSelect, videoSelect];

            function gotDevices(deviceInfos) {
                var values = selectors.map(function(select) {
                    return select.value;
                });
                selectors.forEach(function(select) {
                    while (select.firstChild) {
                        select.removeChild(select.firstChild);
                    }
                });
                for (var i = 0; i !== deviceInfos.length; ++i) {
                    var deviceInfo = deviceInfos[i];
                    var option = document.createElement('option');
                    option.value = deviceInfo.deviceId;
                    if (deviceInfo.kind === 'audioinput') {
                        option.text = deviceInfo.label || 'Microfone ' + (audioInputSelect.length + 1);
                        audioInputSelect.appendChild(option);
                    }
                    else if (deviceInfo.kind === 'audiooutput') {
                        option.text = deviceInfo.label || 'Audio ' + (audioOutputSelect.length + 1);
                        audioOutputSelect.appendChild(option);
                    }
                    else if (deviceInfo.kind === 'videoinput') {
                        option.text = deviceInfo.label || 'Câmera ' + (videoSelect.length + 1);
                        videoSelect.appendChild(option);
                    }
                    else {
                        console.log('Some other kind of source/device: ', deviceInfo);
                    }
                }
                selectors.forEach(function(select, selectorIndex) {
                    if (Array.prototype.slice.call(select.childNodes).some(function(n) {return n.value === values[selectorIndex];})) {
                        select.value = values[selectorIndex];
                    }
                });
            }

            navigator.mediaDevices.enumerateDevices().then(gotDevices).catch(handleError);

            function attachSinkId(element, sinkId) {
                if (typeof element.sinkId !== 'undefined') {
                  element.setSinkId(sinkId)
                      .then(function() {
                          console.log('Success, audio output device attached: ' + sinkId);
                      })
                      .catch(function(error) {
                          var errorMessage = error;
                          if (error.name === 'SecurityError') {
                              errorMessage = 'You need to use HTTPS for selecting audio output device: ' + error;
                          }
                          console.error(errorMessage);
                          audioOutputSelect.selectedIndex = 0;
                      });
                }
                else {
                    console.warn('Browser does not support output device selection.');
                }
            }

            function changeAudioDestination() {
                var audioDestination = audioOutputSelect.value;
                attachSinkId(videoElement, audioDestination);
            }

            function gotStream(stream) {
                window.stream = stream;
                videoElement.srcObject = stream;
                return navigator.mediaDevices.enumerateDevices();
            }

            function start() {
                if (window.stream) {
                    window.stream.getTracks().forEach(function(track) {track.stop();});
                }
                var audioSource = audioInputSelect.value;
                var videoSource = videoSelect.value;
                var constraints = {
                    audio: {deviceId: audioSource ? {exact: audioSource} : undefined},
                    video: {deviceId: videoSource ? {exact: videoSource} : undefined}
                };
                navigator.mediaDevices.getUserMedia(constraints).then(gotStream).then(gotDevices).catch(handleError);
            }

            audioInputSelect.onchange = start;
            audioOutputSelect.onchange = changeAudioDestination;
            videoSelect.onchange = start;

            start();

            function handleError(error) {
                console.log('navigator.getUserMedia error: ', error);
            }

            /*WEBRTC*/
            var webrtc;

            function abrirChat() {
                webrtc = new $xirsys.simplewebrtc();
                webrtc.connect(xirsysConnect.data,
                    {
                        localVideoEl: 'localVideo',
                        remoteVideosEl: 'remotesVideos',
                        autoRequestMedia: true,
                        debug: false,
                        detectSpeakingEvents: false,
                        autoAdjustMic: false,

                    },
                    application
                );

            }

            function application ($inst) {

                var room = $routeParams.hash;

                webrtc.prepareRoom(room);
                webrtc.on('readyToCall', function () {
                    console.log("Entrando na sala "+room)
                    webrtc.joinRoom(room);
                });

                webrtc.on('videoAdded', function (video, peer) {
                    console.log("Video adicionado");
                    var remotes = document.getElementById('remotes');
                    if (remotes) {
                        var container = document.createElement('div');
                        container.className = 'videoContainerRemote';
                        container.id = 'container_' + webrtc.getDomId(peer);
                        container.appendChild(video);
                        video.oncontextmenu = function(){return false;};
                        remotes.appendChild(container);

                        if (peer && peer.pc) {
                            peer.pc.on('iceConnectionStateChange', function (event) {
                                switch (peer.pc.iceConnectionState) {
                                    case 'checking':
                                        $("#chat-textoconexao").html('Conectando...');
                                        break;
                                    case 'connected':
                                    case 'completed':
                                        $("#chat-textoconexao").html('Conectado.');
                                        $(".sk-fading-circle").hide();
                                        break;
                                    case 'disconnected':
                                        $("#chat-textoconexao").html('Desconectado.');
                                        break;
                                    case 'failed':
                                        $("#chat-textoconexao").html('Falha de conexão.');
                                        break;
                                    case 'closed':
                                        $("#chat-textoconexao").html('Conexão encerrada.');
                                        $scope.fecharVideo();
                                        break;
                                }
                            });
                        }
                    }
                });


                webrtc.on('videoRemoved', function (video, peer) {
                    console.log('video removed ', peer);
                    var remotes = document.getElementById('remotes');
                    var el = document.getElementById('container_' + webrtc.getDomId(peer));
                    if (remotes && el) {
                        remotes.removeChild(el);
                    }
                });

                webrtc.on('iceFailed', function (peer) {
                    var connstate = document.querySelector('#container_' + webrtc.getDomId(peer) + ' .connectionstate');
                    if (connstate) {
                        $("#chat-textoconexao").html('Falha de conexão.');
                        fileinput.disabled = 'disabled';
                    }
                });

                webrtc.on('connectivityError', function (peer) {
                    var connstate = document.querySelector('#container_' + webrtc.getDomId(peer) + ' .connectionstate');
                    if (connstate) {
                        $("#chat-textoconexao").html('Falha de conexão.');
                        fileinput.disabled = 'disabled';
                    }
                });

                webrtc.on('channelMessage', function (peer, label, data) {
                    if (data.type == 'volume') {
                        console.log('own volume', data.volume);
                    }
                });

                webrtc.on('volumeChange', function (volume, treshold) {
                    console.log('own volume', volume);
                });
            }

            $(document).ready(function(){
                abrirChat();
                var w = $(window).width();
                var h = $(window).height();
                $(".videoContainer").css({
                    'width': 200,
                    'height': 200,
                    'left': w-200,
                    'top': h-200
                });
                $("#remotes").css({'height': h-70});
                $(".sk-fading-circle").css({
                    'top': (h/2)-40,
                    'left': (w/2)-40
                });
                $("body").css({'overflow':'hidden'});
            });

            $(window).resize(function(){
                var w = $(window).width();
                var h = $(window).height();
                $(".videoContainer").css({
                    'width': 200,
                    'height': 200,
                    'left': w-200,
                    'top': h-200
                });
                $("#remotes").css({'height': h-70});
                $(".sk-fading-circle").css({
                    'top': (h/2)-40,
                    'left': (w/2)-40
                });
            });
            
            
        });
    };

    if ($rootScope.logado === undefined || $rootScope.logado === false)
        window.location.href = "#/principal";
    else
        $scope.recarregar();
});